/**
 * Copyright (c) 2004 Logos GmbH Rostock (www.logos-ib.de).
 * All rights reserved.
 *
 * THIS SOFTWARE IS  PROVIDED  "AS IS"  AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF  MERCHANTABILITY  AND  FITNESS  FOR  A PARTICULAR  PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL  LOGOS GMBH  OR ITS CONTRIBUTORS BE
 * LIABLE FOR ANY  DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
 * OR CONSEQUENTIAL DAMAGES  (INCL., BUT NOT LIMITED TO, PROCUREMENT
 * OF SUBSTITUTE GOODS OR SERVICES;  LOSS OF USE, DATA, OR  PROFITS;
 * OR BUSINESS INTERRUPTION)  HOWEVER  CAUSED  AND  ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,  OR TORT (INCL.
 * NEGLIGENCE OR OTHERWISE)  ARISING  IN  ANY  WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */



package de.inovat.kex.bast.common;

//~ NICHT JDK IMPORTE =========================================================

import de.bsvrz.dav.daf.main.ClientDavInterface;

//~ KLASSEN ===================================================================

/**
 * <p>Klasse, die eine ClientDavConnection global zur Verf&uuml;gung stellt.</p>
 * </p>
 * Klasse wurde berschrieben: ClientDavInterface wird in der Klasse
 * {@link de.bsvrz.sys.funclib.application.StandardApplication} erstellt und
 * ber die Methode {@link #initDav(de.bsvrz.dav.daf.main.ClientDavInterface)}
 * hier initialisiert.
 * </p>
 * @author LOGOS GmbH Rostock (www.logos-ib.de)
 * @author Ralf Trier
 * @version $Id: LogosClientDavConnection.java 442 2008-11-10 06:59:32Z Schawaller $
 */
public class NetzClientDavConnection {

    /** Datenverteilerverbindung */
    private static ClientDavInterface _dav;

    //~ GET METHODEN ==========================================================

    /**
     * gibt die letzte ClientDavConnection zurck oder null.
     *
     * @return ClientDavConnection
     */
    public static ClientDavInterface getInstance() {
        return _dav;
    }

    //~ METHODEN ==============================================================

    /**
     * Initialisiere ClientDavInterface.
     *
     * @param dav ClientDavInterface.
     */
    public static void initDav(ClientDavInterface dav) {
        _dav = dav;
    }
}


//~Formatiert mit 'inovat Kodierkonvention' am 26.07.12
