/**
 * Copyright (c) 2004 Logos GmbH Rostock (www.logos-ib.de).
 * All rights reserved.
 *
 * THIS SOFTWARE IS  PROVIDED  "AS IS"  AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF  MERCHANTABILITY  AND  FITNESS  FOR  A PARTICULAR  PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL  LOGOS GMBH  OR ITS CONTRIBUTORS BE
 * LIABLE FOR ANY  DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
 * OR CONSEQUENTIAL DAMAGES  (INCL., BUT NOT LIMITED TO, PROCUREMENT
 * OF SUBSTITUTE GOODS OR SERVICES;  LOSS OF USE, DATA, OR  PROFITS;
 * OR BUSINESS INTERRUPTION)  HOWEVER  CAUSED  AND  ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,  OR TORT (INCL.
 * NEGLIGENCE OR OTHERWISE)  ARISING  IN  ANY  WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

package de.inovat.kex.bast.common.datawrapper;

import de.bsvrz.dav.daf.main.Data;



/*
 * Revision 1.1  2007/07/04 11:43:11  Trier
 * Neuordnung
 */

/**
 * kapselt die AttributListe atl.status.
 * 
 * @author LOGOS GmbH Rostock (www.logos-ib.de)
 * @author J. Schawaller
 * @version $Id: AtlStatus.java 442 2008-11-10 06:59:32Z Schawaller $
 */
public class AtlStatus {

  private Data _Data;

  public static final String ATTR_NAME_ERFASSUNG = "Erfassung";
  public static final String ATTR_NAME_PLFORMAL = "PlFormal";
  public static final String ATTR_NAME_PLLOGISCH = "PlLogisch";
  public static final String ATTR_NAME_MESSWERTERSETZUNG = "MessWertErsetzung";



  public AtlStatus(Data data) {
    _Data = data;
  }

  public void doInitialize() {
    AtlStatusExterneErfassung atlStatusExterneErfassung = new AtlStatusExterneErfassung(_Data.getItem("Erfassung"));
    AtlStatusPlausibilitaetsPruefungFormal atlStatusPlausibilitaetsPruefungFormal = new AtlStatusPlausibilitaetsPruefungFormal(_Data.getItem("PlFormal"));
    AtlStatusPlausibilitaetsPruefungLogisch atlStatusPlausibilitaetsPruefungLogisch = new AtlStatusPlausibilitaetsPruefungLogisch(_Data.getItem("PlLogisch"));
    AtlStatusMessWertErsetzung atlStatusMessWertErsetzung = new AtlStatusMessWertErsetzung(_Data.getItem("MessWertErsetzung"));

    atlStatusExterneErfassung.setNichtErfasst(true);
    atlStatusPlausibilitaetsPruefungFormal.setWertMax(false);
    atlStatusPlausibilitaetsPruefungFormal.setWertMin(false);
    atlStatusPlausibilitaetsPruefungLogisch.setWertMaxLogisch(false);
    atlStatusPlausibilitaetsPruefungLogisch.setWertMinLogisch(false);
    atlStatusMessWertErsetzung.setImplausibel(false);
    atlStatusMessWertErsetzung.setInterpoliert(false);
  }


  public AtlStatusExterneErfassung  getErfassung() {
    return new AtlStatusExterneErfassung(_Data.getItem("Erfassung"));
  }

  public AtlStatusPlausibilitaetsPruefungFormal  getPlFormal() {
    return new AtlStatusPlausibilitaetsPruefungFormal(_Data.getItem("PlFormal"));
  }

  public AtlStatusPlausibilitaetsPruefungLogisch  getPlLogisch() {
    return new AtlStatusPlausibilitaetsPruefungLogisch(_Data.getItem("PlLogisch"));
  }

  public AtlStatusMessWertErsetzung  getMessWertErsetzung() {
      return new AtlStatusMessWertErsetzung(_Data.getItem("MessWertErsetzung"));
  }

}

