 /**
 * Copyright (c) 2004 Logos GmbH Rostock (www.logos-ib.de).
 * All rights reserved.
 *
 * THIS SOFTWARE IS  PROVIDED  "AS IS"  AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF  MERCHANTABILITY  AND  FITNESS  FOR  A PARTICULAR  PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL  LOGOS GMBH  OR ITS CONTRIBUTORS BE
 * LIABLE FOR ANY  DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
 * OR CONSEQUENTIAL DAMAGES  (INCL., BUT NOT LIMITED TO, PROCUREMENT
 * OF SUBSTITUTE GOODS OR SERVICES;  LOSS OF USE, DATA, OR  PROFITS;
 * OR BUSINESS INTERRUPTION)  HOWEVER  CAUSED  AND  ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,  OR TORT (INCL.
 * NEGLIGENCE OR OTHERWISE)  ARISING  IN  ANY  WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
package de.inovat.kex.bast.common.objectwrapper;
/*
 * Revision 1.2  2007/11/26 12:10:19  Trier
 * <Kein Kommentar eingegeben>
 */
import de.bsvrz.dav.daf.main.Data;
import de.bsvrz.dav.daf.main.config.AttributeGroup;
import de.bsvrz.dav.daf.main.config.ConfigurationObject;
import de.bsvrz.dav.daf.main.config.ConfigurationObjectType;
import de.bsvrz.dav.daf.main.config.DataModel;
import de.bsvrz.dav.daf.main.config.SystemObject;
import de.inovat.kex.bast.common.DataModellMismatchException;
import de.inovat.kex.bast.common.NetzClientDavConnection;

import java.util.List;
import java.util.WeakHashMap;
/**
 * kapselt den DatenModellTyp AuswerteQuerschnitt
 * 
 * @author LOGOS GmbH Rostock (www.logos-ib.de)
 * @author Ralf Trier
 * @version $Id: AuswerteQuerschnitt.java 442 2008-11-10 06:59:32Z Schawaller $
 */
public class AuswerteQuerschnitt
    extends ConfigurationObjectWrapper {

  private static WeakHashMap<String, AuswerteQuerschnitt> __Cache = new WeakHashMap<String, AuswerteQuerschnitt>();

  private static ConfigurationObjectType __ConfigurationObjectType;
  private static AttributeGroup __AtgAuswerteQuerschnitt;

  private LangZeitZaehlStelle _LangZeitZaehlStelle;
  private MessQuerschnitt _MessQuerschnitt;
  private String _Bezeichnung;
  private String _Himmelsrichtung;

  public String getBezeichnung() {
    return _Bezeichnung;
  }
  public String getHimmelsrichtung() {
    return _Himmelsrichtung;
  }
  public MessQuerschnitt getMessQuerschnitt() {
    return _MessQuerschnitt;
  }

  private AuswerteQuerschnitt(ConfigurationObject confObj) throws DataModellMismatchException {
    super(confObj);
  }

  protected void initData(ConfigurationObject confObj) throws DataModellMismatchException {
    Data oData = confObj.getConfigurationData(__AtgAuswerteQuerschnitt);
    if (oData != null) {
      _MessQuerschnitt = MessQuerschnitt.getInstance((ConfigurationObject)oData.getReferenceValue("Messquerschnitt").getSystemObject());
      _MessQuerschnitt.setAuswerteQuerschnitt(this);
      _Bezeichnung = oData.getTextValue("Bezeichnung").getText();
      if (oData.getUnscaledValue("Himmelsrichtung").isState()) {
        _Himmelsrichtung = oData.getUnscaledValue("Himmelsrichtung").getState().getName();
      }
    }
    __Cache.put(this.getPID(), this);
  }

  /**
   * gibt die Instance des AuswerteQuerschnittes mit der PID zurck. Es wird eine
   * DataModellObjectNotFoundException geworfen, wenn die PID nicht vorhanden
   * ist oder das zur PID gehrende Objekt nicht vom typ strae ist.
   *
   * @param pid String
   * @throws DataModellMismatchException
   * @return Strasse
   */
  public static AuswerteQuerschnitt getInstance(String pid) throws DataModellMismatchException {
    AuswerteQuerschnitt retValue = __Cache.get(pid);
    if (retValue == null) {
      Object o = NetzClientDavConnection.getInstance().getDataModel().getObject(pid);
      if ((o != null) && (o instanceof ConfigurationObject)) {
        retValue = AuswerteQuerschnitt.getInstanceIntern( (ConfigurationObject)o );
      }
    }
    return retValue;
  }

  public static AuswerteQuerschnitt getInstance(ConfigurationObject confObj) throws DataModellMismatchException {
    AuswerteQuerschnitt retValue = __Cache.get(confObj.getPid());
    if (retValue == null) {
      retValue = AuswerteQuerschnitt.getInstanceIntern(confObj);
    }
    return retValue;
  }

  private static synchronized AuswerteQuerschnitt getInstanceIntern(ConfigurationObject confObj) throws DataModellMismatchException {
    AuswerteQuerschnitt retValue = __Cache.get(confObj.getPid());
    if (retValue == null) {
      if (__ConfigurationObjectType == null) {
        AuswerteQuerschnitt.init();
      }
      retValue = new AuswerteQuerschnitt(confObj);
    }
    return retValue;
  }



  /**
   * gibt die DatenModellObjekte vom typ auswerteQuerschnitt zurck.
   *
   * @throws DataModellMismatchException
   * @return Strasse[]
   */
  public static AuswerteQuerschnitt[] getAll() throws DataModellMismatchException {
    if (__ConfigurationObjectType == null) {
      AuswerteQuerschnitt.init();
    }
    AuswerteQuerschnitt[] retValue;
    if (__ConfigurationObjectType != null) {
      List<SystemObject> list = __ConfigurationObjectType.getElements();
      retValue = new AuswerteQuerschnitt[list.size()];
      for (int i = 0; i < list.size(); i++) {
        retValue[i] = AuswerteQuerschnitt.getInstanceIntern( (ConfigurationObject)list.get(i) );
      }
    }
    else {
      retValue = new AuswerteQuerschnitt[0];
    }
    return retValue;
  }

  public String toString() {
    StringBuffer sb = new StringBuffer();
    sb.append("AuswerteQuerschnitt -- PID: \"").append(getPID()).append("\"  ");
    sb.append("Name: \"").append(getName()).append("\"  ");
    sb.append("Bezeichnung: \"").append(_Bezeichnung).append("\"");
    return sb.toString();
  }


  public String getMultilineRepresentation() {
    return getMultilineRepresentation(0);
  }

  public String getMultilineRepresentation(int indent) {
    String lf = System.getProperty("line.separator");
    StringBuffer sIndent = new StringBuffer();
    for (int i=0; i<indent; i++) {
      sIndent.append(' ');
    }
    StringBuffer sb = new StringBuffer();

    sb.append(sIndent).append("PID: \"").append(getPID()).append("\"").append(lf);
    sb.append(sIndent).append("Name: \"").append(getName()).append("\"").append(lf);
    sb.append(sIndent).append("Bezeichnung: \"").append(_Bezeichnung).append("\"").append(lf);
    sb.append(sIndent).append("MessQuerschnitt: ").append(lf);
    if (_MessQuerschnitt != null) {
      sb.append(_MessQuerschnitt.getMultilineRepresentation(indent + 2));
    }
    else {
      sb.append(sIndent).append("  kein Messquerschnitt vorhanden");
    }
    return sb.toString();
  }

  public void setLangZeitZaehlStelle(LangZeitZaehlStelle lzz) {
    _LangZeitZaehlStelle = lzz;
  }

  /**
   * gibt die Langzeizz&auml;hlstelle zur&uuml;ck, wenn dieses Objekt durch eine
   * Langzeizz&auml;hlstelle erzeugt wurde.
   *
   * @return LangZeitZaehlStelle
   */
  public LangZeitZaehlStelle getLangZeitZaehlStelle() {
    return _LangZeitZaehlStelle;
  }


  public String getTreeString() {
    StringBuffer sb = new StringBuffer();
    if (_Bezeichnung.startsWith("GE")) {
      sb.append("RFB nach ").append(_LangZeitZaehlStelle.getGegenFernziel());
      return sb.toString();
    }
    else {
      if (_Bezeichnung.startsWith("IN")) {
        sb.append("RFB nach ").append(_LangZeitZaehlStelle.getInFernziel());
        return sb.toString();
      }
      else {
        return getName();
      }
    }
  }

  ConfigurationObjectType getType() {
    return __ConfigurationObjectType;
  }


  private static synchronized void init() {
    if (__ConfigurationObjectType == null) {
      DataModel model = NetzClientDavConnection.getInstance().getDataModel();
      __ConfigurationObjectType = (ConfigurationObjectType)model.getType("typ.auswerteQuerschnitt");
      __AtgAuswerteQuerschnitt = model.getAttributeGroup("atg.auswerteQuerschnitt");
      List<SystemObject> list = __ConfigurationObjectType.getElements();
      model.getConfigurationData(list, __AtgAuswerteQuerschnitt);
    }
  }

}
