/**
 * Copyright (c) 2004 Logos GmbH Rostock (www.logos-ib.de).
 * All rights reserved.
 *
 * THIS SOFTWARE IS  PROVIDED  "AS IS"  AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF  MERCHANTABILITY  AND  FITNESS  FOR  A PARTICULAR  PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL  LOGOS GMBH  OR ITS CONTRIBUTORS BE
 * LIABLE FOR ANY  DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
 * OR CONSEQUENTIAL DAMAGES  (INCL., BUT NOT LIMITED TO, PROCUREMENT
 * OF SUBSTITUTE GOODS OR SERVICES;  LOSS OF USE, DATA, OR  PROFITS;
 * OR BUSINESS INTERRUPTION)  HOWEVER  CAUSED  AND  ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,  OR TORT (INCL.
 * NEGLIGENCE OR OTHERWISE)  ARISING  IN  ANY  WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
package de.inovat.kex.bast.common.objectwrapper;

import java.util.List;

import de.bsvrz.dav.daf.main.Data;
import de.bsvrz.dav.daf.main.config.AttributeGroup;
import de.bsvrz.dav.daf.main.config.ConfigurationObject;
import de.bsvrz.dav.daf.main.config.ConfigurationObjectType;
import de.bsvrz.dav.daf.main.config.DataModel;
import de.bsvrz.dav.daf.main.config.SystemObject;
import de.inovat.kex.bast.common.*;

/*
 * Revision 1.1  2007/07/04 11:43:54  Trier
 * Neuordnung
 */

/**
 * kapselt den DatenModellTyp verkehrsDatenQuelleVirtuell
 * 
 * @author LOGOS GmbH Rostock (www.logos-ib.de)
 * @author J. Schawaller
 * @version $Id: FahrstreifenQuelleVirtuell.java 442 2008-11-10 06:59:32Z Schawaller $
 */
public class FahrstreifenQuelleVirtuell
    extends ConfigurationObjectWrapper implements FahrstreifenQuelle {

  private static ConfigurationObjectType __ConfigurationObjectType;
  private static AttributeGroup __AtgVerkehrsDatenQuelleVirtuell;
  private String _BerechnungsVorschrift;

  public String getBerechnungsVorschrift() {
    return _BerechnungsVorschrift;
  }

  protected FahrstreifenQuelleVirtuell(String pid) throws DataModellMismatchException, DataModellObjectNotFoundException {
    super(pid);
  }

  protected FahrstreifenQuelleVirtuell(ConfigurationObject confObj) throws DataModellMismatchException {
    super(confObj);
  }

  protected void initData(ConfigurationObject confObj) {
    Data oData = confObj.getConfigurationData(__AtgVerkehrsDatenQuelleVirtuell);
    _BerechnungsVorschrift = oData.getTextValue("BerechnungsVorschrift").getText();
  }

  /**
   * gibt ein Array aller Objekte zurck, die vom Typ typ.verkehrsDatenQuelleVirtuell
   * sind.
   *
   * @return FahrstreifenQuelleASCII[]
   * @throws DataModellMismatchException
   */
  public static FahrstreifenQuelleVirtuell[] getAll() throws DataModellMismatchException {
    List<SystemObject> list = NetzClientDavConnection.getInstance().getDataModel().getType("typ.verkehrsDatenQuelleVirtuell").getElements();
    FahrstreifenQuelleVirtuell[] retValue = new FahrstreifenQuelleVirtuell[list.size()];
    for (int i = 0; i < list.size(); i++) {
      retValue[i] = new FahrstreifenQuelleVirtuell( (ConfigurationObject) list.get(i));
    }
    return retValue;
  }

  public String toString() {
    StringBuffer sb = new StringBuffer();
    sb.append("PID: \"").append(getPID());
    sb.append("\"  BerechnungsVorschrift: \"").append(_BerechnungsVorschrift);
    sb.append("\"");
    return sb.toString();
  }

  public String getTreeString() {
    return getName();
  }

  ConfigurationObjectType getType() {
    if (__ConfigurationObjectType==null) {
      DataModel model = NetzClientDavConnection.getInstance().getDataModel();
      __ConfigurationObjectType = (ConfigurationObjectType)model.getType("typ.verkehrsDatenQuelleVirtuell");
      __AtgVerkehrsDatenQuelleVirtuell = model.getAttributeGroup("atg.verkehrsDatenQuelleVirtuell");
      List<SystemObject> list = __ConfigurationObjectType.getElements();
      model.getConfigurationData(list, __AtgVerkehrsDatenQuelleVirtuell);
    }
    return __ConfigurationObjectType;
  }


}
